%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global	mainver		1.8.1
#%%global	prever			.beta.4

%global	mainrel		2
%global	prerpmver	%(echo "%{?prever}" | sed -e 's|\\.||g')

%global	gemname		nokogiri

%global	ruby19		1
%global	gemdir		%{gem_dir}
%global	geminstdir	%{gem_instdir}
%global	gem_name	%{gemname}


# Note for packager:
# Nokogiri 1.4.3.1 gem says that Nokogiri upstream will
# no longer support ruby 1.8.6 after 2010-08-01, so
# it seems that 1.4.3.1 is the last version for F-13 and below.

Summary:	An HTML, XML, SAX, and Reader parser
Name:		%{?scl_prefix}rubygem-%{gemname}
Version:	%{mainver}
Release:	%{?prever:0.}%{mainrel}%{?prever:.%{prerpmver}}%{?dist}
Group:		Development/Languages
License:	MIT
URL:		http://nokogiri.rubyforge.org/nokogiri/
Source0:	http://gems.rubyforge.org/gems/%{gemname}-%{mainver}%{?prever}.gem
# Shut down libxml2 version unmatching warning
Patch0:         %{pkg_name}-1.6.6.4-shutdown-libxml2-warning.patch

BuildRequires:   %{?scl_prefix}ruby(release)
BuildRequires:   %{?scl_prefix}ruby(rubygems)
##
## For %%check
BuildRequires:   %{?scl_prefix}rubygem(minitest)
BuildRequires:   %{?scl_prefix}rubygems-devel
#BuildRequires:  ruby(racc)
##
## Others
BuildRequires:   libxml2-devel
BuildRequires:   libxslt-devel
BuildRequires:   %{?scl_prefix}ruby-devel
Requires:        %{?scl_prefix}ruby(release)
Requires:        %{?scl_prefix}ruby(rubygems)
Provides:	 %{?scl_prefix}rubygem(%{gemname}) = %{version}-%{release}

%description
Nokogiri is an HTML, XML, SAX, and Reader parser.  Among
Nokogiri's many features is the ability to search documents via XPath
or CSS3 selectors.

%if 0
%package	jruby
Summary:	JRuby support for %{name}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description	jruby
This package contains JRuby support for %{name}.
%endif


%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-%{gemname}
Summary:	Non-Gem support package for %{gemname}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Provides:	ruby(%{gemname}) = %{version}-%{release}

%description	-n ruby-%{gemname}
This package provides non-Gem support for %{gemname}.

%prep
%{?scl:scl enable %{scl} - << \EOF}
gem unpack %{SOURCE0}
%{?scl:EOF}
%setup -q -D -T -n  %{gem_name}-%{version}

# patches
%patch0 -p1

%{?scl:scl enable %{scl} - << \EOF}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:EOF}

# remove bundled external libraries
sed -i \
        -e 's|, "ports/archives/[^"][^"]*"||g' \
        -e 's|, "ports/patches/[^"][^"]*"||g' \
        %{gem_name}.gemspec
# Actually not needed when using system libraries
sed -i -e '\@mini_portile@d' %{gem_name}.gemspec

%build
# 1.6.0 needs this
export NOKOGIRI_USE_SYSTEM_LIBRARIES=yes

# Create the gem as gem install only works on a gem file
%{?scl:scl enable %{scl} - << \EOF}
env LANG=ja_JP.UTF-8 gem build %{gem_name}.gemspec
%{?scl:EOF}

%{?scl:scl enable %{scl} - << \EOF}
%gem_install
%{?scl:EOF}

# Remove precompiled Java .jar file
rm -f .%{geminstdir}/lib/*.jar
# For now remove JRuby support
rm -rf .%{geminstdir}/ext/java

%install
mkdir -p %{buildroot}%{gem_dir}
cp -pa .%{gem_dir}/* %{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{gem_extdir_mri}/%{gem_name}
cp -a .%{gem_extdir_mri}/gem.build_complete %{buildroot}%{gem_extdir_mri}/
cp -a .%{gem_extdir_mri}/%{gem_name}/*.so %{buildroot}%{gem_extdir_mri}/%{gem_name}/

mkdir -p %{buildroot}%{_bindir}
cp -a ./%{_bindir}/* %{buildroot}%{_bindir}

# remove all shebang
for f in $(find %{buildroot}%{geminstdir} -name \*.rb)
do
	sed -i -e '/^#!/d' $f
	chmod 0644 $f
done

# cleanups
rm -rf %{buildroot}%{gem_instdir}/ext/%{gemname}/
rm -rf %{buildroot}%{gem_instdir}/tmp/

%files
%defattr(-,root, root,-)
%dir %{gem_instdir}/
%doc %{geminstdir}/README*
%license %{geminstdir}/LICENSE*
%{_bindir}/%{gemname}
%{gem_extdir_mri}
%{gem_instdir}/bin/
%{gem_libdir}
%{gem_spec}
%exclude %{gem_cache}

%files	doc
%defattr(-,root,root,-)
%doc %{gem_docdir}
%{gem_instdir}/.autotest
%{gem_instdir}/.cross_rubies
%{gem_instdir}/.editorconfig
%{gem_instdir}/.gemtest
%{gem_instdir}/.travis.yml
%{gem_instdir}/*_all
%{gem_instdir}/*.yml
%{geminstdir}/[A-Z]*
%{gem_instdir}/patches/
%{gem_instdir}/suppressions
%{gem_instdir}/tasks/
%{gem_instdir}/test/

%changelog
* Wed Oct 04 2017 Satoe Imaishi <simaishi@redhat.com> - 1.8.1-2
- Update to 1.8.1

* Wed Jun 07 2017 Satoe Imaishi <simaishi@redhat.com> - 1.7.2-1
- Update to 1.7.2

* Tue Aug 23 2016 Satoe Imaishi <simaishi@redhat.com> - 1.6.8-1
- Update to 1.6.8

* Tue Oct 27 2015 Satoe Imaishi <simaishi@redhat.com> - 1.6.6.2-3
- Fix dependency and remove extra files from doc package

* Thu Sep 10 2015 Satoe Imaishi <simaishi@redhat.com> - 1.6.6.2-2
- Follow ruby packaging guideline to build/install

* Fri Sep 04 2015 Satoe Imaishi <simaishi@redhat.com> - 1.6.6.2-1
- Build 1.6.6.2 for rh-ruby22

* Fri Apr 17 2015 Joe VLcek <jvlcek@redhat.com> - 1.5.11.2
- Leave arch dependent files where gem install put them.

* Tue Dec 09 2014 Mo Morsi <mmorsi@redhat.com> - 1.5.6-4
- Fixed files section for gem_extdir

* Sat Feb 23 2013 Mo Morsi <mmorsi@redhat.com> - 1.5.6-3
- Removed obsoletes (bug 1054866)

* Sat Feb 23 2013 Vít Ondruch <vondruch@redhat.com> - 1.5.6-2
- Rebuild for https://fedoraproject.org/wiki/Features/Ruby_2.0.0

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.6-1.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Jan  1 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.5.6-1
- A Happy New Year
- 1.5.6

* Fri Aug 17 2012 Vít Ondruch <vondruch@redhat.com> - 1.5.5-2
- Rebuilt againts libxml2 2.9.

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.5-1.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jun 25 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.5-1
- 1.5.5

* Mon May 28 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.2-3
- Fix Obsoletes (bug 822931)

* Mon Apr  9 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.2-1
- 1.5.2

* Tue Apr 03 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.5.0-3
- Fix conditionals for F17 to work for RHEL 7 as well.

* Tue Jan 24 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.0-2
- F-17: rebuild for ruby19
- For now aviod build failure by touching some files

* Thu Jan 18 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.0-1
- 1.5.0

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.0-0.5.beta4.1
- F-17: Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Sun Jun 26 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.0-0.5.beta4
- Remove unneeded patch

* Thu Mar 18 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.5.0-0.4.beta4
- Patch for newer rake to make testsuite run

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.0-0.3.beta4.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jan 30 2011 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.5.0-0.3.beta4
- 1.5.0.beta.4

* Tue Dec  7 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.5.0-0.2.beta3
- 1.5.0.beta.3

* Sun Oct 17 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.5.0-0.1.beta2
- Try 1.5.0.beta.2

* Fri Jul 30 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.4.3.1-1
- 1.4.3.1

* Wed May 26 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.4.2-1
- 1.4.2

* Thu Apr 29 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.4.1-2
- Fix build failure with libxml2 >= 2.7.7

* Tue Dec 15 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.4.1-1
- 1.4.1

* Mon Nov  9 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.4.0-1
- 1.4.0

* Sat Aug 22 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.3-2
- Fix test failure on sparc

* Wed Jul 29 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.3-1
- 1.3.3

* Sat Jul 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.2-3
- F-12: Mass rebuild

* Thu Jul  2 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.2-2
- Enable test
- Recompile with -O2

* Thu Jun 25 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.2-1
- 1.3.2

* Thu Jun 11 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.3.1-1
- 1.3.1

* Thu Mar 26 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.2.3-1
- 1.2.3

* Thu Mar 19 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.2.2-1
- 1.2.2

* Thu Mar 12 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.2.1-1
- 1.2.1

* Tue Feb 24 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.1.1-2
- F-11: Mass rebuild

* Thu Jan 15 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.1.1-1
- 1.1.1

* Thu Dec 25 2008 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1.1.0-1
- Initial packaging

